class Hello {
	/* Defines a method main. When the program Hello is run, this method
	   will execute. We will learn what public, static, and String[] 
	   mean in due time. 

	   void is the return type for the main method. void means return
	   nothing at all. */

	public static void main(String[] args) {
		System.out.println("Hello world");

		/* sets aside memory for an integer, and calls it x */
		int x;

		/* before we use x, we must declare and give it a type */
		x = 12;
		x = x + 1;
		System.out.println(x);

		/* If incommented, the following line will cause trouble,
		   since x can only refer to an integer! */
		// x = "horse";

		System.out.println(larger(5, 10));
		countDownFrom(5);
	}

	/* Defines a function larger that returns the larger of two integers. 
	   This function only works on integers. This function only supports
	   integers, i.e. will not allow us to compare doubles, strings,
	   or anything else. We'll learn how to write polymorphic Java functions 
	   later on in the course. 

	   This function takes two integer arguments and returns an int.
	   The 'int' right after static refers to the return type of larger. 

	   In Java, we must always specify the type fo parameters as well as
	   the return type of methods. */

	static int larger(int x, int y) {
		if (x > y)
			return x;

		return y;
	}	

	/** Prints all numbers from N down to 1, inclusive.
	    Example: countDownFrom(5) would print 5 4 3 2 1 */

	static void countDownFrom(int N) {
		if (N == 0)
			return;

		System.out.println(N);
		countDownFrom(N-1);
	}
}

// Java's type system:
// Good: Safer -- compiler finds type errors at compile time. especially handy for writing programs in large teams.
// Good: Faster -- type checking occurs at compile time (in Python it happens at runtime) 
// Bad: More verbose.
